/*
 * Written by Milan Straka as a part of Factoring polynomials
 * over finite fields (fapof) project.
 * Copyright (C) 2006  Milan Straka
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "common.h"

#include <cctype>

int verbose=0;

bool parse_unsigned(const char* str,unsigned *d) {
  *d=0;
  while (isspace(*str)) str++;
  if (*str=='+') str++;
  if (!isdigit(*str)) return false;
  while (isdigit(*str))
    *d=(*d)*10 + *str++ - '0';
  return true;
}

unsigned usqrt(unsigned n) { 
  unsigned ret=1; 
  while (ret*ret<n && /*overflow*/ret<65536) ret++; 
  return ret;
}

