/*
 * Written by Milan Straka as a part of Factoring polynomials
 * over finite fields (fapof) project.
 * Copyright (C) 2006  Milan Straka
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef COMMON_H_BY_MILAN_STRAKA_2006
#define COMMON_H_BY_MILAN_STRAKA_2006

#include <cstdlib>

#define LOG(...) (verbose && fprintf(stderr,__VA_ARGS__))
#define LOGMORE(...) (verbose>1 && fprintf(stderr,__VA_ARGS__) && fflush(stderr))
#define ERROR(...) fprintf(stderr,__VA_ARGS__)
#define STOP(...) (fprintf(stderr,"Fatal error, terminating: " __VA_ARGS__),exit(0))

#define DEFINE_STRUCTURES(P) typedef std::pair<unsigned, P> prvek;		\
                             typedef std::vector<prvek> pole;			\
                             typedef std::vector<prvek>::iterator pole_it;	\
                             typedef std::map<unsigned, P> mapa;		\
                             typedef std::map<unsigned, P>::iterator mapa_it;

#define DEFINE_STRUCTURES_TEMPLATE(P) typedef std::pair<unsigned, P> prvek;		\
                             typedef std::vector<prvek> pole;				\
                             typedef typename std::vector<prvek>::iterator pole_it;	\
                             typedef std::map<unsigned, P> mapa;			\
                             typedef typename std::map<unsigned, P>::iterator mapa_it;

extern int verbose;
bool parse_unsigned(const char* str,unsigned *d);
unsigned usqrt(unsigned n);

#endif
