/*
 * Written by Milan Straka as a part of Factoring polynomials
 * over finite fields (fapof) project.
 * Copyright (C) 2006  Milan Straka
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifdef POLYNOMIAL_H_INCLUDING_PROTOTYPES
private:
struct CloneWrapper {
public:
  CloneWrapper(const polynom& pa) : a(pa) {}
  const polynom& a;
};
public:
CloneWrapper clone(void) const { return CloneWrapper(*this); }
void operator=(const CloneWrapper& c);
polynom copy(void) const { return polynom(p->deg,*this); }

#define CLONE_COEFS(to,from) {to->deg=from->deg; 					\
                             for (unsigned i=from->deg;i>0;i--) to->c[i]=from->c[i];	\
                             to->c[0]=from->c[0];}

#endif

#ifdef POLYNOMIAL_H_INCLUDING_FUNCTIONS
template<class T, int id>
inline void polynomial<T,id>::operator=(const CloneWrapper& c) {
  polynom_coefs *orig=c.a.p;
  CLONE_COEFS(p,orig) //p <- orig
}

#endif
