/*
 * Written by Milan Straka as a part of Factoring polynomials
 * over finite fields (fapof) project.
 * Copyright (C) 2006  Milan Straka
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifdef POLYNOMIAL_H_INCLUDING_PROTOTYPES
public:
void monify(void);
polynom leadingCoef(void) { polynom b(0); b.p->deg=0; b.p->c[0]=p->c[p->deg]; return b; }
#define MONIFY_COEFS(p) { DEGRIFY_COEFS(p); 						\
                          if (p->deg>0 || p->c[0]!=T::fzero()) {			\
                            T inverze=T::invert(p->c[p->deg]);				\
			    for (unsigned i=p->deg;i>0;i--) p->c[i]=p->c[i]*inverze;	\
			    p->c[0]=p->c[0]*inverze;					\
                          }								\
                        }
#endif

#ifdef POLYNOMIAL_H_INCLUDING_FUNCTIONS
template<class T, int id>
inline void polynomial<T,id>::monify(void) {
  MONIFY_COEFS(p);
}
#endif
